# Generated by sila2.code_generator; sila2.__version__: 0.12.2
from __future__ import annotations

from abc import ABC, abstractmethod
from typing import TYPE_CHECKING, Any, List

from sila2.server import FeatureImplementationBase, MetadataDict

from .connectionconfigurationservice_types import (
    ConnectSiLAClient_Responses,
    DisableServerInitiatedConnectionMode_Responses,
    DisconnectSiLAClient_Responses,
    EnableServerInitiatedConnectionMode_Responses,
)

if TYPE_CHECKING:
    from ...server import Server


class ConnectionConfigurationServiceBase(FeatureImplementationBase, ABC):
    parent_server: Server

    def __init__(self, parent_server: Server):
        """

        This Feature MUST be implemented by each SiLA Server that offers a Server-initiated connection.

        The server-initiated connection mode is persistent, it keeps the state after a restart.
        Connect to a SiLA Client passing the required information and optionally keep the connection details persistent.
        The SiLA Server will reconnect to the persistent SiLA Clients after a restart.

        """
        super().__init__(parent_server=parent_server)

    @abstractmethod
    def get_ServerInitiatedConnectionModeStatus(self, *, metadata: MetadataDict) -> bool:
        """
        Whether or not the server initiated connection mode is active.

        :param metadata: The SiLA Client Metadata attached to the call
        :return: Whether or not the server initiated connection mode is active.
        """

    @abstractmethod
    def get_ConfiguredSiLAClients(self, *, metadata: MetadataDict) -> List[Any]:
        """

        Get the configured SiLA Clients used for server-initiated connections.


          :param metadata: The SiLA Client Metadata attached to the call
          :return:
        Get the configured SiLA Clients used for server-initiated connections.

        """

    @abstractmethod
    def EnableServerInitiatedConnectionMode(
        self, *, metadata: MetadataDict
    ) -> EnableServerInitiatedConnectionMode_Responses:
        """
        Enable the server initiated connection mode.


        :param metadata: The SiLA Client Metadata attached to the call

        """

    @abstractmethod
    def DisableServerInitiatedConnectionMode(
        self, *, metadata: MetadataDict
    ) -> DisableServerInitiatedConnectionMode_Responses:
        """
        Disable the server initiated connection mode.


        :param metadata: The SiLA Client Metadata attached to the call

        """

    @abstractmethod
    def ConnectSiLAClient(
        self, ClientName: str, SiLAClientHost: str, SiLAClientPort: int, Persist: bool, *, metadata: MetadataDict
    ) -> ConnectSiLAClient_Responses:
        """
        Connect a new SiLA Client.


        :param ClientName: Name of the SiLA Client. Has to be unique among the already connected clients (see property ConfiguredSiLAClients).

        :param SiLAClientHost: Host Address of the new SiLA Client.

        :param SiLAClientPort: Port of the new SiLA Client.

        :param Persist: Whether or not to store the SiLA Client Connection.

        :param metadata: The SiLA Client Metadata attached to the call

        """

    @abstractmethod
    def DisconnectSiLAClient(
        self, ClientName: str, Remove: bool, *, metadata: MetadataDict
    ) -> DisconnectSiLAClient_Responses:
        """
        Disconnect a configured SiLA Client.


        :param ClientName: Name of the SiLA Client.

        :param Remove: Whether or not to remove the stored SiLA Client connection details.

        :param metadata: The SiLA Client Metadata attached to the call

        """
